# Ionic SvelteKit

<a href="https://github.com/ionic-sveltekit/core#readme">
	<picture>
		<img src="assets/logo.png" alt="Ionic UI components with SvelteKit" />
	</picture>
</a>

[![License](https://img.shields.io/npm/l/svelte.svg)](LICENSE)

## Get Started

The easiest way to create a new Ionic SvelteKit project is by using the [@ionic-sveltekit/create](https://github.com/ionic-sveltekit/create#readme) interactive CLI tool:

```bash
npx @ionic-sveltekit/create
```
View the [@ionic-sveltekit/create documentation](https://github.com/ionic-sveltekit/create#readme) for a full list of options.

## What is Ionic SvelteKit

The combination of Ionic UI components and SvelteKit web framework.

### What is Ionic?

Ionic is a powerful cross-platform UI toolkit for building native-quality iOS, Android, and Progressive Web Apps with HTML, CSS, and JavaScript.

To learn more about available components and their options, see Ionic's [UI Components](https://ionicframework.com/docs/components) documentation.

### What is SvelteKit?

SvelteKit is a framework for rapidly developing robust, performant web applications using [Svelte](https://svelte.dev). If you’re coming from React, SvelteKit is similar to Next. If you’re coming from Vue, SvelteKit is similar to Nuxt.

To learn more about the kinds of applications you can build with SvelteKit, see the [documentation regarding project types](https://svelte.dev/docs/kit/project-types).

### What is Svelte?

Svelte is a new way to build web applications. It's a compiler that takes your declarative components and converts them into efficient JavaScript that surgically updates the DOM.

Learn more at the [Svelte website](https://svelte.dev)

## Why is Ionic SvelteKit

This project combines 2 of my favorite tools: Ionic UI components & SvelteKit.

- SvelteKit provides everything necessary to create a functional, fullstack, performant web app. This include logical, file-based routing, state management, backend server capabilities, and Svelte's elegant reactivity. It provides an ideal developer experience while minimizing opaque magic.
- Ionic UI components offer an attractive set of consistent UI elements with which to build rich online experiences.

By including both of these tools in 1 wrapper, the time to get from initial concept to functional experience is greatly reduced.

## Acknowledgements

This project would not be possible without the foundational work of [@Tommertom](https://github.com/Tommertom)([LinkedIn](https://www.linkedin.com/in/tgruintjes/)) and his [svelte-ionic-app](https://github.com/Tommertom/svelte-ionic-app) project, upon which all of the work in this [organization](https://github.com/ionic-sveltekit) is based.

Thank you, Tom!

## License

[MIT](LICENSE)
